      PROGRAM GTAU_INT ! Bernd Berg, Nov 3, 2005.
C
C - Acceptance rate versus integrated autocorrelatiion time 
C   for Gaussian data generated by Metropolis MC.
C
      include '../../ForLib/implicit.sta'
      include '../../ForLib/constants.par'
      PARAMETER(A=8.0D00)
      PARAMETER(IUO=6,IUD0=10,IUD1=11,ISEED1=1,ISEED2=0)
      PARAMETER(K=21,NDAT=2**K,NBINS=32,LMEAN=.FALSE.,NT=127)
      DIMENSION DATA(NDAT),ACORJ(NBINS,0:NT),ACOR(0:NT)
      DIMENSION ACINTJ(NBINS,0:NT),ACINT(0:NT),WORK(NBINS)
      LTEST=.true.
      LTEST=.false.
      IF(LTEST) STOP "GTAU_INT: LTEST."
C
      WRITE(IUO,'(/," METROPOLIS FOR GAUSSIAN RANDOM NUMBERS")')
      WRITE(IUO,'(" RANGE A:",F16.4)') A
      WRITE(IUO,'(" K,NDAT=2**k,NBINS:",3I9)') K,NDAT,NBINS
      CALL RMASET(IUO,IUD0,ISEED1,ISEED2,'ranmar.d')
C
      CALL GAU_METRO(A,NDAT,DATA,ACPT) ! Gaussian Metropolis data.
C
      OPEN(IUD0,FILE="acor.d",FORM='formatted',STATUS='unknown')
      DO IT=0,NT
        ACOR(IT)=AUTCORF(IT,NDAT,DATA,LMEAN)
        CALL AUTCORJ(IT,NDAT,NBINS,DATA,WORK,ACORJ(1,IT),LMEAN)
        CALL STEBJ0(NBINS,ACORJ(1,IT),ACM,ACV,ACE)
        ABIAS=100*ABS(ACOR(IT)-ACM)/ABS(ACOR(IT)) ! Bias in %.
        WRITE(IUD0,'(1I6,3F14.8,1F14.4)') IT,ACOR(IT),ACM,ACE,ABIAS
      END DO
      CLOSE(IUD0)
C
      OPEN(IUD0,FILE="at_int.d",FORM='formatted',STATUS='unknown')
      CALL AC_INT(NT,ACOR,ACINT)
      CALL AC_INTJ(NT,NBINS,ACORJ,ACINTJ)
      TAU_INT=HALF*ACINT(0)
      LMONOTON=.TRUE.
      DO IT=0,NT
        CALL STEBJ0(NBINS,ACINTJ(1,IT),ACM,ACV,ACE)
        ABIAS=100*ABS(ACINT(IT)-ACM)/ACINT(IT) ! Bias in %.
        WRITE(IUD0,'(1I6,3F14.8,1F14.4)') IT,ACINT(IT),ACM,ACE,ABIAS
        IF(LMONOTON) THEN
          IF(ACINT(IT).GE.TAU_INT) THEN
            TAU_INT=ACINT(IT)
            TAU_INTE=ACE
            ITEST=IT
          ELSE
            LMONOTON=.FALSE. 
          ENDIF
        ENDIF
      END DO
      CLOSE(IUD0)
C
      WRITE(IUO,'(/,2X,"RUN FINISHED. PLOT WITH *.plt DRIVERS.",/)')
C     WRITE(IUO,'(2X,"A SOMEWHAT UNRELIABLE TAU_INT ESTIMATE:",/)')
C     WRITE(IUO,'(6X,"ITEST",7X,"TAU_INT",6X,"TAU_INTE",9X,"ACPT")')
C     WRITE(IUO,'(/,I10,3F14.4,/)') ITEST,TAU_INT,TAU_INTE,ACPT
C
      STOP
      END

      INCLUDE '../../ForLib/ac_int.f'
      INCLUDE '../../ForLib/ac_intj.f'
      INCLUDE '../../ForLib/autcorf.f'
      INCLUDE '../../ForLib/autcorj.f'
      INCLUDE '../../ForLib/bias.f'
      INCLUDE '../../ForLib/bining.f'
      INCLUDE '../../ForLib/datjack.f'
      INCLUDE '../../ForLib/gau_metro.f'
      INCLUDE '../../ForLib/ranmar.f'
      INCLUDE '../../ForLib/rmaset.f'
      INCLUDE '../../ForLib/steb0.f'
      INCLUDE '../../ForLib/stebj0.f'
      INCLUDE '../../ForLib/stmean.f'
